/**
* Show how to use the i_PCI3116_Write1AnalogOutput method
**/
#include "stdafx.h"

/* maximum output value in unipolar mode */
#define MAX_OUTPUT_VALUE	2047

/* increment speed */
#define INCREMENT_RATE		50

/* output channel is 0 */
#define	OUTPUT_CHANNEL		0

/**
* Entry point
**/
int _tmain( int /*argc*/, _TCHAR* /*argv[]*/ )
{
	INT returnValue = 0;
	HANDLE	boardHandle = NULL;
	WORD value = 0;

	/* call the util method to open a board */
	returnValue = OpenBoard(&boardHandle);
	if (returnValue != 0)
	{
		printf("Error while opening the board : %d \n", (int) returnValue);
		_getch();
		return -1;
	}

	/* display some useful informations */
	printf("\n");
	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n");
	printf("* Write one analog output sample.\n");
	printf("* The sample enables to write the analog output 0 in UNIPOLAR mode.\n");
	printf("* Use ESC to exit the sample. Use '+' and '-' to increment or decrement the output value\n");
	printf("* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\n\n");

	/* endless loop */
	for(;;)
	{
		/* do the user hit a keyboard touch */
		if ( _kbhit() )
		{
			switch ( _getch() )
			{
				/* increment */
				case 43:
					if ( (value + INCREMENT_RATE) < MAX_OUTPUT_VALUE )
					{
						value += INCREMENT_RATE;
					}
					else
					{
						value = MAX_OUTPUT_VALUE;
					}
					/* write the new output */
					returnValue = i_PCI3116_Write1AnalogOutput( boardHandle,
						OUTPUT_CHANNEL,
						PCI3116_OUTPUT_MODE_UNIPOLAR,
						value);
					if ( returnValue != 0 )
					{
						printf("error while setting output : %d \n", returnValue);
						_getch();
						return -1;
					}
					break;

				/* decrement */
				case 45:
					if ( (value - INCREMENT_RATE) >= 0 )
					{
						value -= INCREMENT_RATE;
					}
					else
					{
						value = 0;
					}
					/* write the new output */
					returnValue = i_PCI3116_Write1AnalogOutput( boardHandle,
						OUTPUT_CHANNEL,
						PCI3116_OUTPUT_MODE_UNIPOLAR,
						value);
					if ( returnValue != 0 )
					{
						printf("error while setting output : %d \n", returnValue);
						_getch();
						return -1;
					}
					break;

				/* exit */
				case 27:
					/* close board and return */
					returnValue = i_PCI3116_CloseBoard(boardHandle);
					if ( returnValue != 0 )
					{
						printf("Error % in i_PCI3116_CloseBoard\n", returnValue);
						_getch();
						return -1;
					}
					return 0;
			}
		}
		/* print the current value */
		printf("Value is : 0x%.4x \t", (int)value );
		Sleep(100);
		DisplayRunningStatus();
	}
}

